#include <iostream>
#include <algorithm>
#include <cmath>
#include "bind.hpp"

template<typename T1, typename T2>
bool equ(T1 t1, T2 t2/*, double threshold*/) {  return t1 == t2; }
template<typename T1, typename T2>
bool equthres(T1 t1, T2 t2, double threshold) {  return std::fabs (double (t1 - t2)) <= threshold; }

int main(int argc, char* argv[])
{
	int ia1[] = {1,2,3,4,5};
	std::cout << *std::find_if(ia1, ia1+5, boost::bind(equ<int,int>, _1, 5)) << std::endl;
	std::cout << *std::find_if(ia1, ia1+5, boost::bind(equthres<int,int>, _1, 5, 2.0)) << std::endl;
	return 0;
}
